##// END OF EJS Templates
Merge branch 'master' of https://github.com/drtyhlpr/rpi23-gen-image into drtyhlpr-master
vidal -
r212:015fbfd50212 Fusion
parent child
Show More
@@ -1,658 +1,659
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie" and "stretch" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 10+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 49
50 50 # Debian release
51 51 RELEASE=${RELEASE:=jessie}
52 52 KERNEL_ARCH=${KERNEL_ARCH:=arm}
53 53 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
54 54 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
55 55 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
56 56 if [ "$KERNEL_ARCH" = "arm64" ] ; then
57 57 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
58 58 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
59 59 else
60 60 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
61 61 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
62 62 fi
63 63 if [ "$RELEASE_ARCH" = "arm64" ] ; then
64 64 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
65 65 else
66 66 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
67 67 fi
68 68 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
69 69
70 70 # URLs
71 71 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
72 72 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
73 73 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm80211/brcm}
74 74 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
75 75 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
76 76 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
77 77
78 78 # Build directories
79 79 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
80 80 BUILDDIR="${BASEDIR}/build"
81 81
82 82 # Prepare date string for default image file name
83 83 DATE="$(date +%Y-%m-%d)"
84 84 if [ -z "$KERNEL_BRANCH" ] ; then
85 85 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
86 86 else
87 87 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
88 88 fi
89 89
90 90 # Chroot directories
91 91 R="${BUILDDIR}/chroot"
92 92 ETC_DIR="${R}/etc"
93 93 LIB_DIR="${R}/lib"
94 94 BOOT_DIR="${R}/boot/firmware"
95 95 KERNEL_DIR="${R}/usr/src/linux"
96 96 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
97 97
98 98 # Firmware directory: Blank if download from github
99 99 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
100 100
101 101 # General settings
102 102 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
103 103 PASSWORD=${PASSWORD:=raspberry}
104 104 USER_PASSWORD=${USER_PASSWORD:=raspberry}
105 105 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
106 106 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
107 107 EXPANDROOT=${EXPANDROOT:=true}
108 108
109 109 # Keyboard settings
110 110 XKB_MODEL=${XKB_MODEL:=""}
111 111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 112 XKB_VARIANT=${XKB_VARIANT:=""}
113 113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114 114
115 115 # Network settings (DHCP)
116 116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117 117
118 118 # Network settings (static)
119 119 NET_ADDRESS=${NET_ADDRESS:=""}
120 120 NET_GATEWAY=${NET_GATEWAY:=""}
121 121 NET_DNS_1=${NET_DNS_1:=""}
122 122 NET_DNS_2=${NET_DNS_2:=""}
123 123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 124 NET_NTP_1=${NET_NTP_1:=""}
125 125 NET_NTP_2=${NET_NTP_2:=""}
126 126
127 127 # APT settings
128 128 APT_PROXY=${APT_PROXY:=""}
129 129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 130
131 131 # Feature settings
132 132 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
133 133 ENABLE_I2C=${ENABLE_I2C:=false}
134 134 ENABLE_SPI=${ENABLE_SPI:=false}
135 135 ENABLE_IPV6=${ENABLE_IPV6:=true}
136 136 ENABLE_SSHD=${ENABLE_SSHD:=true}
137 137 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
138 138 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
139 139 ENABLE_SOUND=${ENABLE_SOUND:=true}
140 140 ENABLE_DBUS=${ENABLE_DBUS:=true}
141 141 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
142 142 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
143 143 ENABLE_XORG=${ENABLE_XORG:=false}
144 144 ENABLE_WM=${ENABLE_WM:=""}
145 145 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
146 146 ENABLE_USER=${ENABLE_USER:=true}
147 147 USER_NAME=${USER_NAME:="pi"}
148 148 ENABLE_ROOT=${ENABLE_ROOT:=false}
149 149
150 150 # SSH settings
151 151 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
152 152 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
153 153 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
154 154 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
155 155 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
156 156
157 157 # Advanced settings
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 164 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
165 165 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
166 166 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
167 167 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
168 168 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
169 169 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
170 170
171 171 # Kernel compilation settings
172 172 BUILD_KERNEL=${BUILD_KERNEL:=false}
173 173 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
174 174 KERNEL_THREADS=${KERNEL_THREADS:=1}
175 175 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
176 176 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
177 177 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
178 178 if [ "$KERNEL_ARCH" = "arm64" ] ; then
179 179 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
180 180 else
181 181 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
182 182 fi
183 183
184 184 # Kernel compilation from source directory settings
185 185 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
186 186 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
187 187 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
188 188 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
189 189
190 190 # Reduce disk usage settings
191 191 REDUCE_APT=${REDUCE_APT:=true}
192 192 REDUCE_DOC=${REDUCE_DOC:=true}
193 193 REDUCE_MAN=${REDUCE_MAN:=true}
194 194 REDUCE_VIM=${REDUCE_VIM:=false}
195 195 REDUCE_BASH=${REDUCE_BASH:=false}
196 196 REDUCE_HWDB=${REDUCE_HWDB:=true}
197 197 REDUCE_SSHD=${REDUCE_SSHD:=true}
198 198 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
199 199
200 200 # Encrypted filesystem settings
201 201 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
202 202 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
203 203 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
204 204 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
205 205 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
206 206
207 207 # Stop the Crypto Wars
208 208 DISABLE_FBI=${DISABLE_FBI:=false}
209 209
210 210 # Chroot scripts directory
211 211 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
212 212
213 213 # Packages required in the chroot build environment
214 214 APT_INCLUDES=${APT_INCLUDES:=""}
215 # apt-transport-https has been removed from repositories
215 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
216
217 # Package apt-transport-https has been removed from Debian Buster release
216 218 # this induces qemu error 383 which does not prevent building an image
217 219 if [ "$RELEASE" = "buster" ] ; then
218 APT_INCLUDES="${APT_INCLUDES},apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
219 else
220 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
220 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/apt-transport-https,//")"
221 221 fi
222
222 223 # Packages required for bootstrapping
223 224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
224 225 MISSING_PACKAGES=""
225 226
226 227 # Packages installed for c/c++ build environment in chroot (keep empty)
227 228 COMPILER_PACKAGES=""
228 229
229 230 set +x
230 231
231 232 # Set Raspberry Pi model specific configuration
232 233 if [ "$RPI_MODEL" = 2 ] ; then
233 234 DTB_FILE=${RPI2_DTB_FILE}
234 235 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
235 236 elif [ "$RPI_MODEL" = 3 ] ; then
236 237 DTB_FILE=${RPI3_DTB_FILE}
237 238 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
238 239 BUILD_KERNEL=true
239 240 else
240 241 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
241 242 exit 1
242 243 fi
243 244
244 245 # Check if the internal wireless interface is supported by the RPi model
245 246 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
246 247 echo "error: The selected Raspberry Pi model has no internal wireless interface"
247 248 exit 1
248 249 fi
249 250
250 251 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
251 252 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
252 253 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
253 254 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
254 255 exit 1
255 256 fi
256 257 fi
257 258
258 259 # Build RPi2/3 Linux kernel if required by Debian release
259 260 if [ "$RELEASE" = "stretch" ] ; then
260 261 BUILD_KERNEL=true
261 262 fi
262 263
263 264 # Add packages required for kernel cross compilation
264 265 if [ "$BUILD_KERNEL" = true ] ; then
265 266 if [ "$KERNEL_ARCH" = "arm" ] ; then
266 267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
267 268 else
268 269 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
269 270 fi
270 271 fi
271 272
272 273 # Add libncurses5 to enable kernel menuconfig
273 274 if [ "$KERNEL_MENUCONFIG" = true ] ; then
274 275 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
275 276 fi
276 277
277 278 # Stop the Crypto Wars
278 279 if [ "$DISABLE_FBI" = true ] ; then
279 280 ENABLE_CRYPTFS=true
280 281 fi
281 282
282 283 # Add cryptsetup package to enable filesystem encryption
283 284 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
284 285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
285 286 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
286 287
287 288 if [ -z "$CRYPTFS_PASSWORD" ] ; then
288 289 echo "error: no password defined (CRYPTFS_PASSWORD)!"
289 290 exit 1
290 291 fi
291 292 ENABLE_INITRAMFS=true
292 293 fi
293 294
294 295 # Add initramfs generation tools
295 296 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
296 297 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
297 298 fi
298 299
299 300 # Add device-tree-compiler required for building the U-Boot bootloader
300 301 if [ "$ENABLE_UBOOT" = true ] ; then
301 302 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
302 303 fi
303 304
304 305 # Check if root SSH (v2) public key file exists
305 306 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
306 307 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
307 308 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
308 309 exit 1
309 310 fi
310 311 fi
311 312
312 313 # Check if $USER_NAME SSH (v2) public key file exists
313 314 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
314 315 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
315 316 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
316 317 exit 1
317 318 fi
318 319 fi
319 320
320 321 # Check if all required packages are installed on the build system
321 322 for package in $REQUIRED_PACKAGES ; do
322 323 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
323 324 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
324 325 fi
325 326 done
326 327
327 328 # If there are missing packages ask confirmation for install, or exit
328 329 if [ -n "$MISSING_PACKAGES" ] ; then
329 330 echo "the following packages needed by this script are not installed:"
330 331 echo "$MISSING_PACKAGES"
331 332
332 333 echo -n "\ndo you want to install the missing packages right now? [y/n] "
333 334 read confirm
334 335 [ "$confirm" != "y" ] && exit 1
335 336
336 337 # Make sure all missing required packages are installed
337 338 apt-get -qq -y install ${MISSING_PACKAGES}
338 339 fi
339 340
340 341 # Check if ./bootstrap.d directory exists
341 342 if [ ! -d "./bootstrap.d/" ] ; then
342 343 echo "error: './bootstrap.d' required directory not found!"
343 344 exit 1
344 345 fi
345 346
346 347 # Check if ./files directory exists
347 348 if [ ! -d "./files/" ] ; then
348 349 echo "error: './files' required directory not found!"
349 350 exit 1
350 351 fi
351 352
352 353 # Check if specified KERNELSRC_DIR directory exists
353 354 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
354 355 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
355 356 exit 1
356 357 fi
357 358
358 359 # Check if specified UBOOTSRC_DIR directory exists
359 360 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
360 361 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
361 362 exit 1
362 363 fi
363 364
364 365 # Check if specified FBTURBOSRC_DIR directory exists
365 366 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
366 367 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
367 368 exit 1
368 369 fi
369 370
370 371 # Check if specified CHROOT_SCRIPTS directory exists
371 372 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
372 373 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
373 374 exit 1
374 375 fi
375 376
376 377 # Check if specified device mapping already exists (will be used by cryptsetup)
377 378 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
378 379 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
379 380 exit 1
380 381 fi
381 382
382 383 # Don't clobber an old build
383 384 if [ -e "$BUILDDIR" ] ; then
384 385 echo "error: directory ${BUILDDIR} already exists, not proceeding"
385 386 exit 1
386 387 fi
387 388
388 389 # Setup chroot directory
389 390 mkdir -p "${R}"
390 391
391 392 # Check if build directory has enough of free disk space >512MB
392 393 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
393 394 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
394 395 exit 1
395 396 fi
396 397
397 398 set -x
398 399
399 400 # Call "cleanup" function on various signals and errors
400 401 trap cleanup 0 1 2 3 6
401 402
402 403 # Add required packages for the minbase installation
403 404 if [ "$ENABLE_MINBASE" = true ] ; then
404 405 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
405 406 fi
406 407
407 408 # Add required locales packages
408 409 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
409 410 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
410 411 fi
411 412
412 413 # Add parted package, required to get partprobe utility
413 414 if [ "$EXPANDROOT" = true ] ; then
414 415 APT_INCLUDES="${APT_INCLUDES},parted"
415 416 fi
416 417
417 418 # Add dbus package, recommended if using systemd
418 419 if [ "$ENABLE_DBUS" = true ] ; then
419 420 APT_INCLUDES="${APT_INCLUDES},dbus"
420 421 fi
421 422
422 423 # Add iptables IPv4/IPv6 package
423 424 if [ "$ENABLE_IPTABLES" = true ] ; then
424 425 APT_INCLUDES="${APT_INCLUDES},iptables"
425 426 fi
426 427
427 428 # Add openssh server package
428 429 if [ "$ENABLE_SSHD" = true ] ; then
429 430 APT_INCLUDES="${APT_INCLUDES},openssh-server"
430 431 fi
431 432
432 433 # Add alsa-utils package
433 434 if [ "$ENABLE_SOUND" = true ] ; then
434 435 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
435 436 fi
436 437
437 438 # Add rng-tools package
438 439 if [ "$ENABLE_HWRANDOM" = true ] ; then
439 440 APT_INCLUDES="${APT_INCLUDES},rng-tools"
440 441 fi
441 442
442 443 # Add fbturbo video driver
443 444 if [ "$ENABLE_FBTURBO" = true ] ; then
444 445 # Enable xorg package dependencies
445 446 ENABLE_XORG=true
446 447 fi
447 448
448 449 # Add user defined window manager package
449 450 if [ -n "$ENABLE_WM" ] ; then
450 451 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
451 452
452 453 # Enable xorg package dependencies
453 454 ENABLE_XORG=true
454 455 fi
455 456
456 457 # Add xorg package
457 458 if [ "$ENABLE_XORG" = true ] ; then
458 459 APT_INCLUDES="${APT_INCLUDES},xorg"
459 460 fi
460 461
461 462 # Replace selected packages with smaller clones
462 463 if [ "$ENABLE_REDUCE" = true ] ; then
463 464 # Add levee package instead of vim-tiny
464 465 if [ "$REDUCE_VIM" = true ] ; then
465 466 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
466 467 fi
467 468
468 469 # Add dropbear package instead of openssh-server
469 470 if [ "$REDUCE_SSHD" = true ] ; then
470 471 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
471 472 fi
472 473 fi
473 474
474 475 # Configure kernel sources if no KERNELSRC_DIR
475 476 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
476 477 KERNELSRC_CONFIG=true
477 478 fi
478 479
479 480 # Configure reduced kernel
480 481 if [ "$KERNEL_REDUCE" = true ] ; then
481 482 KERNELSRC_CONFIG=false
482 483 fi
483 484
484 485 # Execute bootstrap scripts
485 486 for SCRIPT in bootstrap.d/*.sh; do
486 487 head -n 3 "$SCRIPT"
487 488 . "$SCRIPT"
488 489 done
489 490
490 491 ## Execute custom bootstrap scripts
491 492 if [ -d "custom.d" ] ; then
492 493 for SCRIPT in custom.d/*.sh; do
493 494 . "$SCRIPT"
494 495 done
495 496 fi
496 497
497 498 # Execute custom scripts inside the chroot
498 499 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
499 500 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
500 501 chroot_exec /bin/bash -x <<'EOF'
501 502 for SCRIPT in /chroot_scripts/* ; do
502 503 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
503 504 $SCRIPT
504 505 fi
505 506 done
506 507 EOF
507 508 rm -rf "${R}/chroot_scripts"
508 509 fi
509 510
510 511 # Remove c/c++ build environment from the chroot
511 512 chroot_remove_cc
512 513
513 514 # Remove apt-utils
514 515 if [ "$RELEASE" = "jessie" ] ; then
515 516 chroot_exec apt-get purge -qq -y --force-yes apt-utils
516 517 fi
517 518
518 519 # Generate required machine-id
519 520 MACHINE_ID=$(dbus-uuidgen)
520 521 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
521 522 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
522 523
523 524 # APT Cleanup
524 525 chroot_exec apt-get -y clean
525 526 chroot_exec apt-get -y autoclean
526 527 chroot_exec apt-get -y autoremove
527 528
528 529 # Unmount mounted filesystems
529 530 umount -l "${R}/proc"
530 531 umount -l "${R}/sys"
531 532
532 533 # Clean up directories
533 534 rm -rf "${R}/run/*"
534 535 rm -rf "${R}/tmp/*"
535 536
536 537 # Clean up files
537 538 rm -f "${ETC_DIR}/ssh/ssh_host_*"
538 539 rm -f "${ETC_DIR}/dropbear/dropbear_*"
539 540 rm -f "${ETC_DIR}/apt/sources.list.save"
540 541 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
541 542 rm -f "${ETC_DIR}/*-"
542 543 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
543 544 rm -f "${ETC_DIR}/resolv.conf"
544 545 rm -f "${R}/root/.bash_history"
545 546 rm -f "${R}/var/lib/urandom/random-seed"
546 547 rm -f "${R}/initrd.img"
547 548 rm -f "${R}/vmlinuz"
548 549 rm -f "${R}${QEMU_BINARY}"
549 550
550 551 # Calculate size of the chroot directory in KB
551 552 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
552 553
553 554 # Calculate the amount of needed 512 Byte sectors
554 555 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
555 556 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
556 557 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
557 558
558 559 # The root partition is EXT4
559 560 # This means more space than the actual used space of the chroot is used.
560 561 # As overhead for journaling and reserved blocks 25% are added.
561 562 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
562 563
563 564 # Calculate required image size in 512 Byte sectors
564 565 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
565 566
566 567 # Prepare image file
567 568 if [ "$ENABLE_SPLITFS" = true ] ; then
568 569 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
569 570 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
570 571 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
571 572 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
572 573
573 574 # Write firmware/boot partition tables
574 575 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
575 576 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
576 577 EOM
577 578
578 579 # Write root partition table
579 580 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
580 581 ${TABLE_SECTORS},${ROOT_SECTORS},83
581 582 EOM
582 583
583 584 # Setup temporary loop devices
584 585 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
585 586 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
586 587 else # ENABLE_SPLITFS=false
587 588 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
588 589 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
589 590
590 591 # Write partition table
591 592 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
592 593 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
593 594 ${ROOT_OFFSET},${ROOT_SECTORS},83
594 595 EOM
595 596
596 597 # Setup temporary loop devices
597 598 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
598 599 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
599 600 fi
600 601
601 602 if [ "$ENABLE_CRYPTFS" = true ] ; then
602 603 # Create dummy ext4 fs
603 604 mkfs.ext4 "$ROOT_LOOP"
604 605
605 606 # Setup password keyfile
606 607 touch .password
607 608 chmod 600 .password
608 609 echo -n ${CRYPTFS_PASSWORD} > .password
609 610
610 611 # Initialize encrypted partition
611 612 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
612 613
613 614 # Open encrypted partition and setup mapping
614 615 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
615 616
616 617 # Secure delete password keyfile
617 618 shred -zu .password
618 619
619 620 # Update temporary loop device
620 621 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
621 622
622 623 # Wipe encrypted partition (encryption cipher is used for randomness)
623 624 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
624 625 fi
625 626
626 627 # Build filesystems
627 628 mkfs.vfat "$FRMW_LOOP"
628 629 mkfs.ext4 "$ROOT_LOOP"
629 630
630 631 # Mount the temporary loop devices
631 632 mkdir -p "$BUILDDIR/mount"
632 633 mount "$ROOT_LOOP" "$BUILDDIR/mount"
633 634
634 635 mkdir -p "$BUILDDIR/mount/boot/firmware"
635 636 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
636 637
637 638 # Copy all files from the chroot to the loop device mount point directory
638 639 rsync -a "${R}/" "$BUILDDIR/mount/"
639 640
640 641 # Unmount all temporary loop devices and mount points
641 642 cleanup
642 643
643 644 # Create block map file(s) of image(s)
644 645 if [ "$ENABLE_SPLITFS" = true ] ; then
645 646 # Create block map files for "bmaptool"
646 647 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
647 648 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
648 649
649 650 # Image was successfully created
650 651 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
651 652 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
652 653 else
653 654 # Create block map file for "bmaptool"
654 655 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
655 656
656 657 # Image was successfully created
657 658 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
658 659 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant